class com.airtightinteractive.apps.viewers.simpleViewer.Image
{
   var mStageManager;
   var mThumbArea;
   var mXMLManager;
   var mImageArea;
   var mIndex;
   var mClip_mc;
   var loaded;
   var mImageURL;
   var mFrame_mc;
   var mImgLoadStatus_mc;
   var mLoader_mc;
   var mLoadNextonDone;
   var mFadeTween;
   var mImageLoadError;
   var mLoader_mcl;
   var mJPGWidth;
   var mJPGHeight;
   function Image(target, index, imageURL)
   {
      this.mStageManager = com.airtightinteractive.apps.viewers.simpleViewer.StageManager.getInstance();
      this.mThumbArea = com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.getInstance();
      this.mXMLManager = com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.getInstance();
      this.mImageArea = com.airtightinteractive.apps.viewers.simpleViewer.ImageArea.getInstance();
      this.mIndex = index;
      var _loc2_ = target.getNextHighestDepth();
      this.mClip_mc = target.createEmptyMovieClip("image" + _loc2_,_loc2_);
      this.loaded = false;
      this.mImageURL = imageURL;
      this.mFrame_mc = this.mClip_mc.createEmptyMovieClip("frame",this.mClip_mc.getNextHighestDepth());
      this.mImgLoadStatus_mc = this.mClip_mc.attachMovie("ImageLoadbar","mcloadbar",this.mClip_mc.getNextHighestDepth());
      var _loc3_ = new Color(this.mImgLoadStatus_mc);
      _loc3_.setRGB(this.mXMLManager.imageFrameColor);
      this.mLoader_mc = this.mClip_mc.createEmptyMovieClip("loader",this.mClip_mc.getNextHighestDepth());
      this.mLoadNextonDone = false;
      this.mFadeTween = new mx.transitions.Tween(this.mClip_mc,"_alpha",null,100,100,1,false);
      this.mClip_mc._visible = false;
      this.mImageLoadError = false;
   }
   function loadImage(loadNextonDone)
   {
      this.mLoadNextonDone = loadNextonDone;
      this.mLoader_mcl = new MovieClipLoader();
      this.mLoader_mcl.addListener(this);
      this.mLoader_mcl.loadClip(this.mImageURL,this.mLoader_mc);
      this.mLoader_mc._visible = false;
      this.resizeImage();
   }
   function onLoadProgress(target, bytesLoaded, bytesTotal)
   {
      var _loc2_ = bytesLoaded / bytesTotal * 100;
      this.mThumbArea.showImageProgress(this.mIndex,_loc2_);
      if(this.mImageArea.currentImageIndex == this.mIndex)
      {
         this.showImageProgress(_loc2_);
      }
   }
   function onLoadInit()
   {
      this.loaded = true;
      this.mLoader_mcl.removeListener(this);
      this.mJPGWidth = this.mLoader_mc._width;
      this.mJPGHeight = this.mLoader_mc._height;
      this.mThumbArea.showImageLoadComplete(this.mIndex);
      if(this.mLoadNextonDone && com.airtightinteractive.apps.viewers.simpleViewer.Options.preloadImages)
      {
         this.mImageArea.loadNextImage();
      }
      this.mImgLoadStatus_mc._visible = false;
   }
   function onLoadError()
   {
      this.mImageLoadError = true;
      if(this.mImageArea.currentImageIndex == this.mIndex)
      {
         this.mImageArea.showImage(this.mIndex);
      }
      if(this.mLoadNextonDone && com.airtightinteractive.apps.viewers.simpleViewer.Options.preloadImages)
      {
         this.mImageArea.loadNextImage();
      }
   }
   function showImage()
   {
      this.resizeImage();
      this.mClip_mc._visible = true;
      this.mClip_mc.swapDepths(999999);
      this.mFadeTween.continueTo(0,1);
      this.mFadeTween.fforward();
      this.mFadeTween.continueTo(0,com.airtightinteractive.apps.viewers.simpleViewer.Options.imageFadeLength);
      this.mFadeTween.onMotionFinished = mx.utils.Delegate.create(this,this.onFadeWaitDone);
   }
   function onFadeWaitDone()
   {
      this.mFadeTween.continueTo(100,com.airtightinteractive.apps.viewers.simpleViewer.Options.imageFadeLength);
      this.mFadeTween.onMotionFinished = null;
      this.mImageArea.fadeInButtons();
   }
   function hideImage()
   {
      this.mFadeTween.continueTo(100,1);
      this.mFadeTween.fforward();
      this.mFadeTween.continueTo(0,com.airtightinteractive.apps.viewers.simpleViewer.Options.imageFadeLength);
      this.mFadeTween.onMotionFinished = mx.utils.Delegate.create(this,this.fadeOutDone);
      this.mImageArea.fadeOutButtons();
   }
   function fadeOutDone()
   {
      this.mClip_mc._visible = false;
      this.mFadeTween.onMotionFinished = null;
   }
   function resizeImage()
   {
      var _loc6_ = undefined;
      var _loc5_ = undefined;
      var _loc2_ = undefined;
      var _loc3_ = undefined;
      var _loc4_ = undefined;
      var _loc8_ = undefined;
      var _loc7_ = undefined;
      var _loc10_ = undefined;
      var _loc9_ = undefined;
      _loc2_ = this.mXMLManager.frameWidth;
      _loc6_ = this.mImageArea.width - _loc2_ * 2;
      _loc5_ = this.mImageArea.height - _loc2_ * 2;
      _loc10_ = _loc6_ / _loc5_;
      _loc9_ = this.mJPGWidth / this.mJPGHeight;
      if(_loc9_ > _loc10_)
      {
         _loc3_ = Math.min(_loc6_,this.mJPGWidth);
         _loc4_ = Math.round(_loc3_ / _loc9_);
      }
      else
      {
         _loc4_ = Math.min(_loc5_,this.mJPGHeight);
         _loc3_ = Math.round(_loc4_ * _loc9_);
      }
      _loc8_ = Math.round((_loc6_ - _loc3_) / 2) + _loc2_;
      _loc7_ = Math.round((_loc5_ - _loc4_) / 2) + _loc2_;
      this.mLoader_mc._width = _loc3_;
      this.mLoader_mc._height = _loc4_;
      this.mLoader_mc._x = _loc8_;
      this.mLoader_mc._y = _loc7_;
      this.mFrame_mc.clear();
      this.mFrame_mc.beginFill(this.mXMLManager.imageFrameColor,100);
      com.airtightinteractive.util.RectUtil.hollowRectangle(this.mFrame_mc,_loc8_ - _loc2_,_loc7_ - _loc2_,_loc8_ + _loc3_ + _loc2_,_loc7_ + _loc4_ + _loc2_,_loc2_);
      this.mFrame_mc.endFill();
      this.mImgLoadStatus_mc._x = Math.round((_loc6_ - this.mImgLoadStatus_mc._width) / 2) + _loc2_;
      this.mImgLoadStatus_mc._y = Math.round((_loc5_ - this.mImgLoadStatus_mc._height) / 2) + _loc2_;
   }
   function setPosn(x, y)
   {
      this.mClip_mc._x = x;
      this.mClip_mc._y = y;
   }
   function showImageProgress(percent)
   {
      this.mImgLoadStatus_mc.mcBar._width = Math.floor(percent / 100 * this.mImgLoadStatus_mc.mcBkgnd._width);
      this.mImgLoadStatus_mc._visible = true;
   }
   function get imageWidth()
   {
      return this.mLoader_mc._width;
   }
   function get imageHeight()
   {
      return this.mLoader_mc._height;
   }
   function get imageX()
   {
      return this.mLoader_mc._x;
   }
   function get imageY()
   {
      return this.mLoader_mc._y;
   }
   function get imageLoadError()
   {
      return this.mImageLoadError;
   }
}
