class com.airtightinteractive.apps.viewers.simpleViewer.ImageArea
{
   var mClip_mc;
   var mXMLManager;
   var mStageManager;
   var mThumbArea;
   var mImages;
   var mImageLoadQueue;
   var mCurrentImageIndex;
   var mImageHolder_mc;
   var mButtonHolder_mc;
   var mNextBtn;
   var mBackBtn;
   var mBtnFadeTween;
   var mError_mc;
   var mWidth;
   var mHeight;
   static var instance;
   function ImageArea()
   {
   }
   static function getInstance()
   {
      if(com.airtightinteractive.apps.viewers.simpleViewer.ImageArea.instance == null)
      {
         com.airtightinteractive.apps.viewers.simpleViewer.ImageArea.instance = new com.airtightinteractive.apps.viewers.simpleViewer.ImageArea();
      }
      return com.airtightinteractive.apps.viewers.simpleViewer.ImageArea.instance;
   }
   function init(target)
   {
      this.mClip_mc = target.createEmptyMovieClip("imageArea",target.getNextHighestDepth());
      this.mXMLManager = com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.getInstance();
      this.mStageManager = com.airtightinteractive.apps.viewers.simpleViewer.StageManager.getInstance();
      this.mThumbArea = com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.getInstance();
      this.mImages = [];
      this.mImageLoadQueue = [];
      this.mCurrentImageIndex = -1;
      this.mImageHolder_mc = this.mClip_mc.createEmptyMovieClip("mcFrame",this.mClip_mc.getNextHighestDepth());
      this.mButtonHolder_mc = this.mClip_mc.createEmptyMovieClip("mcBtn",this.mClip_mc.getNextHighestDepth());
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.enableImageButtons)
      {
         this.mButtonHolder_mc.attachMovie("ImageNextButton","mcNextBtn",this.mButtonHolder_mc.getNextHighestDepth());
         this.mNextBtn = new com.airtightinteractive.apps.viewers.simpleViewer.RolloverButton(this.mButtonHolder_mc.mcNextBtn);
         this.mNextBtn.doAction = mx.utils.Delegate.create(this,this.onClickNext);
         this.mNextBtn.setRGB(this.mXMLManager.imageFrameColor);
         this.mButtonHolder_mc.attachMovie("ImageBackButton","mcBackBtn",this.mButtonHolder_mc.getNextHighestDepth());
         this.mBackBtn = new com.airtightinteractive.apps.viewers.simpleViewer.RolloverButton(this.mButtonHolder_mc.mcBackBtn);
         this.mBackBtn.doAction = mx.utils.Delegate.create(this,this.onClickBack);
         this.mBackBtn.setRGB(this.mXMLManager.imageFrameColor);
         this.mBtnFadeTween = new mx.transitions.Tween(this.mButtonHolder_mc,"_alpha",null,0,0,1,false);
         this.mButtonHolder_mc._visible = false;
         this.mBackBtn.hideOnRollOut = com.airtightinteractive.apps.viewers.simpleViewer.Options.hideImageButtonsOnRollOut;
         this.mNextBtn.hideOnRollOut = com.airtightinteractive.apps.viewers.simpleViewer.Options.hideImageButtonsOnRollOut;
      }
      var _loc2_ = new ContextMenu();
      _loc2_.hideBuiltInItems();
      if(this.mXMLManager.enableRightClickOpen)
      {
         _loc2_.customItems.push(new ContextMenuItem("Open Image in New Window...",mx.utils.Delegate.create(this,this.openImageLink)));
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.enableDownloadLink)
      {
         _loc2_.customItems.push(new ContextMenuItem("Download SimpleViewer",mx.utils.Delegate.create(this,this.openURL)));
      }
      this.mClip_mc.menu = _loc2_;
      this.mError_mc = this.mClip_mc.attachMovie("ErrorIcon","error",this.mClip_mc.getNextHighestDepth());
      this.mError_mc._visible = false;
      var _loc3_ = new Color(this.mError_mc);
      _loc3_.setRGB(this.mXMLManager.imageFrameColor);
   }
   function createImages()
   {
      var _loc2_ = 0;
      while(_loc2_ <= this.mXMLManager.imageCount - 1)
      {
         this.mImages[_loc2_] = new com.airtightinteractive.apps.viewers.simpleViewer.Image(this.mImageHolder_mc,_loc2_,this.mXMLManager.imagePath + this.mXMLManager.imageFileNames[_loc2_],this);
         this.mImageLoadQueue[_loc2_] = _loc2_;
         _loc2_ = _loc2_ + 1;
      }
      this.mImageLoadQueue.reverse();
      this.loadNextImage();
   }
   function loadNextImage()
   {
      var _loc2_ = this.mImageLoadQueue.pop();
      this.mImages[_loc2_].loadImage(true);
   }
   function loadImageOutOfSequence(imageIndex)
   {
      var _loc2_ = com.airtightinteractive.util.ArrayUtil.indexOf(this.mImageLoadQueue,imageIndex);
      if(_loc2_ > -1)
      {
         this.mImageLoadQueue.splice(_loc2_,1);
         this.mImages[imageIndex].loadImage(false);
      }
   }
   function setSize(w, h)
   {
      this.mClip_mc._visible = w > this.mXMLManager.frameWidth * 2 && h > this.mXMLManager.frameWidth * 2;
      this.mWidth = Math.round(w);
      this.mHeight = Math.round(h);
      this.mImages[this.mCurrentImageIndex].resizeImage();
      this.mError_mc._x = this.mWidth / 2;
      this.mError_mc._y = this.mHeight / 2;
      this.resizeImageNavButtons();
   }
   function setPosn(x, y)
   {
      x = Math.round(x);
      y = Math.round(y);
      this.mClip_mc._x = x;
      this.mClip_mc._y = y;
   }
   function showImage(imgIndex)
   {
      if(imgIndex != this.mCurrentImageIndex)
      {
         this.mImages[this.mCurrentImageIndex].hideImage();
      }
      this.mCurrentImageIndex = imgIndex;
      if(this.mImages[this.mCurrentImageIndex].imageLoadError)
      {
         this.mError_mc._visible = true;
         this.mImages[this.mCurrentImageIndex].hideImage();
      }
      else
      {
         this.mError_mc._visible = false;
         this.mImages[this.mCurrentImageIndex].showImage();
      }
      this.mBackBtn.visible = this.mCurrentImageIndex > 0;
      this.mNextBtn.visible = this.mCurrentImageIndex < this.mXMLManager.imageCount - 1;
      this.mStageManager.showCaption(this.mCurrentImageIndex);
   }
   function fadeInButtons()
   {
      this.resizeImageNavButtons();
      this.mBtnFadeTween.continueTo(0,1);
      this.mBtnFadeTween.fforward();
      this.mBtnFadeTween.continueTo(100,com.airtightinteractive.apps.viewers.simpleViewer.Options.imageFadeLength);
   }
   function fadeOutButtons()
   {
      this.resizeImageNavButtons();
      this.mBtnFadeTween.continueTo(100,1);
      this.mBtnFadeTween.fforward();
      this.mBtnFadeTween.continueTo(0,com.airtightinteractive.apps.viewers.simpleViewer.Options.imageFadeLength);
   }
   function resizeImageNavButtons()
   {
      if(this.mImages[this.mCurrentImageIndex].loaded && !this.mImages[this.mCurrentImageIndex].imageLoadError)
      {
         this.mButtonHolder_mc._visible = true;
         var _loc6_ = this.mImages[this.mCurrentImageIndex].imageWidth;
         var _loc5_ = this.mImages[this.mCurrentImageIndex].imageHeight;
         var _loc4_ = this.mImages[this.mCurrentImageIndex].imageX;
         var _loc3_ = this.mImages[this.mCurrentImageIndex].imageY;
         var _loc2_ = this.mXMLManager.frameWidth;
         var _loc7_ = this.mBackBtn.btnWidth;
         this.mBackBtn.setBtnPosn(_loc4_,_loc3_ + _loc5_ / 2 - _loc7_ / 2);
         this.mBackBtn.setHitPosn(_loc4_ - _loc2_,_loc3_ - _loc2_);
         this.mBackBtn.setHitSize(_loc6_ / 3,_loc5_ + _loc2_ * 2);
         this.mNextBtn.setBtnPosn(_loc4_ + _loc6_ - _loc7_,_loc3_ + _loc5_ / 2 - _loc7_ / 2);
         this.mNextBtn.setHitPosn(_loc4_ + _loc2_ + _loc6_ * 2 / 3,_loc3_ - _loc2_);
         this.mNextBtn.setHitSize(_loc6_ / 3,_loc5_ + _loc2_ * 2);
      }
      else
      {
         this.mButtonHolder_mc._visible = false;
      }
   }
   function onClickNext()
   {
      this.mThumbArea.selectedThumbIndex = this.mThumbArea.selectedThumbIndex + 1;
   }
   function onClickBack()
   {
      this.mThumbArea.selectedThumbIndex = this.mThumbArea.selectedThumbIndex - 1;
   }
   function openImageLink()
   {
      getURL(this.mXMLManager.imagePath + this.mXMLManager.imageFileNames[this.mCurrentImageIndex],"_blank");
   }
   function get currentImageIndex()
   {
      return this.mCurrentImageIndex;
   }
   function get width()
   {
      return this.mWidth;
   }
   function get height()
   {
      return this.mHeight;
   }
   function openURL()
   {
      this.mStageManager.openURL();
   }
}
