class com.airtightinteractive.apps.viewers.simpleViewer.XMLManager
{
   var mStageManager;
   var mThumbArea;
   var mImageData_xml;
   var imageCount;
   var imageFileNames;
   var imageCaptions;
   static var instance;
   var maxImageHeight = 640;
   var maxImageWidth = 640;
   var stagePadding = 40;
   var imageFrameColor = 16777215;
   var thumbnailFrameColor = 16777215;
   var pagingArrowsColor = 16777215;
   var captionTextColor = 16777215;
   var titleTextColor = 16777215;
   var frameWidth = 20;
   var thumbnailColumns = 3;
   var thumbnailRows = 4;
   var navPosition = "left";
   var imagePath = "images/";
   var thumbPath = "thumbs/";
   var title = "";
   var enableRightClickOpen = false;
   var backgroundImagePath = null;
   function XMLManager()
   {
      this.mStageManager = com.airtightinteractive.apps.viewers.simpleViewer.StageManager.getInstance();
      this.mThumbArea = com.airtightinteractive.apps.viewers.simpleViewer.ThumbArea.getInstance();
   }
   static function getInstance()
   {
      if(com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.instance == null)
      {
         com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.instance = new com.airtightinteractive.apps.viewers.simpleViewer.XMLManager();
      }
      return com.airtightinteractive.apps.viewers.simpleViewer.XMLManager.instance;
   }
   function set xmlData(xmld)
   {
      this.mImageData_xml = xmld;
      this.imageCount = 0;
      this.imageFileNames = [];
      this.imageCaptions = [];
      var _loc2_ = this.mImageData_xml.firstChild;
      if(_loc2_ == null)
      {
         return;
      }
      this.maxImageWidth = this.setIfValidNumber(_loc2_.attributes.maxImageWidth,this.maxImageWidth);
      this.maxImageHeight = this.setIfValidNumber(_loc2_.attributes.maxImageHeight,this.maxImageHeight);
      this.maxImageWidth = this.setIfValidNumber(_loc2_.attributes.maxImageDimension,this.maxImageWidth);
      this.maxImageHeight = this.setIfValidNumber(_loc2_.attributes.maxImageDimension,this.maxImageHeight);
      this.frameWidth = this.setIfValidNumber(_loc2_.attributes.frameWidth,this.frameWidth);
      this.stagePadding = this.setIfValidNumber(_loc2_.attributes.stagePadding,this.stagePadding);
      this.thumbnailColumns = this.setIfValidNumber(_loc2_.attributes.thumbnailColumns,this.thumbnailColumns);
      this.thumbnailRows = this.setIfValidNumber(_loc2_.attributes.thumbnailRows,this.thumbnailRows);
      this.imageFrameColor = this.setIfValidNumber(_loc2_.attributes.frameColor,this.imageFrameColor);
      this.thumbnailFrameColor = this.setIfValidNumber(_loc2_.attributes.frameColor,this.thumbnailFrameColor);
      this.pagingArrowsColor = this.setIfValidNumber(_loc2_.attributes.frameColor,this.pagingArrowsColor);
      this.captionTextColor = this.setIfValidNumber(_loc2_.attributes.textColor,this.captionTextColor);
      this.titleTextColor = this.setIfValidNumber(_loc2_.attributes.textColor,this.titleTextColor);
      if(this.isValidPath(_loc2_.attributes.imagePath))
      {
         this.imagePath = _loc2_.attributes.imagePath;
      }
      if(this.isValidPath(_loc2_.attributes.thumbPath))
      {
         this.thumbPath = _loc2_.attributes.thumbPath;
      }
      if(this.isValidPath(_loc2_.attributes.backgroundImagePath))
      {
         this.backgroundImagePath = _loc2_.attributes.backgroundImagePath;
      }
      if(_loc2_.attributes.title != undefined)
      {
         this.title = _loc2_.attributes.title;
      }
      if(_loc2_.attributes.navPosition == "top" || _loc2_.attributes.navPosition == "bottom" || _loc2_.attributes.navPosition == "left" || _loc2_.attributes.navPosition == "right")
      {
         this.navPosition = _loc2_.attributes.navPosition;
      }
      if(_loc2_.attributes.enableRightClickOpen == "true")
      {
         this.enableRightClickOpen = true;
      }
      else if(_loc2_.attributes.enableRightClickOpen == "false")
      {
         this.enableRightClickOpen = false;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.maxImageWidth != null)
      {
         this.maxImageWidth = com.airtightinteractive.apps.viewers.simpleViewer.Options.maxImageWidth;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.maxImageHeight != null)
      {
         this.maxImageHeight = com.airtightinteractive.apps.viewers.simpleViewer.Options.maxImageHeight;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.imageFrameColor != null)
      {
         this.imageFrameColor = com.airtightinteractive.apps.viewers.simpleViewer.Options.imageFrameColor;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameColor != null)
      {
         this.thumbnailFrameColor = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailFrameColor;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.pagingArrowsColor != null)
      {
         this.pagingArrowsColor = com.airtightinteractive.apps.viewers.simpleViewer.Options.pagingArrowsColor;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.captionTextColor != null)
      {
         this.captionTextColor = com.airtightinteractive.apps.viewers.simpleViewer.Options.captionTextColor;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.titleTextColor != null)
      {
         this.titleTextColor = com.airtightinteractive.apps.viewers.simpleViewer.Options.titleTextColor;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.frameWidth != null)
      {
         this.frameWidth = com.airtightinteractive.apps.viewers.simpleViewer.Options.frameWidth;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.stagePadding != null)
      {
         this.stagePadding = com.airtightinteractive.apps.viewers.simpleViewer.Options.stagePadding;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailColumns != null)
      {
         this.thumbnailColumns = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailColumns;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailRows != null)
      {
         this.thumbnailRows = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbnailRows;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.navPosition != null)
      {
         this.navPosition = com.airtightinteractive.apps.viewers.simpleViewer.Options.navPosition;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.imagePath != null)
      {
         this.imagePath = com.airtightinteractive.apps.viewers.simpleViewer.Options.imagePath;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbPath != null)
      {
         this.thumbPath = com.airtightinteractive.apps.viewers.simpleViewer.Options.thumbPath;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.title != null)
      {
         this.title = com.airtightinteractive.apps.viewers.simpleViewer.Options.title;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.enableRightClickOpen != null)
      {
         this.enableRightClickOpen = com.airtightinteractive.apps.viewers.simpleViewer.Options.enableRightClickOpen;
      }
      if(com.airtightinteractive.apps.viewers.simpleViewer.Options.backgroundImagePath != null)
      {
         this.backgroundImagePath = com.airtightinteractive.apps.viewers.simpleViewer.Options.backgroundImagePath;
      }
      this.imageCount = Number(_loc2_.childNodes.length);
      var _loc3_ = 0;
      while(_loc3_ < this.imageCount)
      {
         var _loc4_ = _loc2_.childNodes[_loc3_];
         this.imageFileNames.push(_loc4_.childNodes[0].firstChild.nodeValue);
         this.imageCaptions.push(_loc4_.childNodes[1].firstChild.nodeValue);
         _loc3_ = _loc3_ + 1;
      }
      this.mStageManager.onXMLLoaded();
   }
   function setIfValidNumber(xmlVal, defaultVal)
   {
      var _loc2_ = Number(xmlVal);
      if(this.isValidNumber(_loc2_))
      {
         return _loc2_;
      }
      return defaultVal;
   }
   function isValidNumber(x)
   {
      return !(isNaN(x) || x == undefined);
   }
   function isValidPath(s)
   {
      return !(s == "" || s == undefined);
   }
}
